--- linux-linaro-3.4-2012.05-1_original/drivers/celestial/xport/xport_drv1900.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/xport/xport_drv1900.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,278 @@
+#ifndef __XPORT_DRV_H__
+#define __XPORT_DRV_H__
+
+#include "xport_regs1900.h"
+#include "xport_filter1900.h"
+#include <mach/hardware.h>
+
+#define  AUD_TEST
+
+#define XPORT_TIMEOUT           msecs_to_jiffies(5)
+
+#define XPORT_MEM_BASE          (( XPORT_REGION - 0x1000 + 1 ) & ~(0xfff))
+
+#define XPORT_MEM_SIZE          XPORT_SIZE
+
+#define MAX_FILTER_NUM          63
+
+#define XPORT_CHL0_BASE_ADDR_DEF    XPORT_MEM_BASE
+
+#define IN_CHL_UNIT_SIZE_DEF(n)    ((n)==0?IN_CHL0_UNIT_SIZE_DEF: IN_CHL1_UNIT_SIZE_DEF)
+#define IN_CHL_UNIT_NUM_DEF(n)     ((n)==0?IN_CHL0_UNIT_NUM_DEF: IN_CHL1_UNIT_NUM_DEF)
+#define IN_CHL_CFG_DEF(n)          ((n)==0?IN_CHL0_CFG_DEF: IN_CHL1_CFG_DEF)
+#define IN_CHL_BASE_DEF(n)         ((n)==0?IN_CHL0_BASE_ADDR_DEF: IN_CHL1_BASE_ADDR_DEF)
+#define IN_CHL_BUF_SIZE(n)         ((n)==0?IN_CHL0_BUF_SIZE: IN_CHL1_BUF_SIZE)
+
+#ifndef CONFIG_XPORT_BIG_DMABUFFER
+
+#define IN_CHL0_UNIT_SIZE_DEF    512
+#define IN_CHL0_UNIT_NUM_DEF     256
+#define IN_CHL0_BUF_SIZE         0x20000 // should equal/greater than IN_CHL0_UNIT_SIZE_DEF * IN_CHL0_UNIT_NUM_DEF
+#define IN_CHL0_CFG_DEF          ((IN_CHL0_UNIT_NUM_DEF<<8) | (IN_CHL0_UNIT_SIZE_DEF>>3))
+#define IN_CHL0_BASE_ADDR_DEF     XPORT_CHL0_BASE_ADDR_DEF
+
+#define IN_CHL1_UNIT_SIZE_DEF    512
+#define IN_CHL1_UNIT_NUM_DEF     256
+#define IN_CHL1_BUF_SIZE         0x20000 // should equal/greater than IN_CHL1_UNIT_SIZE_DEF * IN_CHL1_UNIT_NUM_DEF
+#define IN_CHL1_CFG_DEF          ((IN_CHL1_UNIT_NUM_DEF<<8) | (IN_CHL1_UNIT_SIZE_DEF>>3))
+#define IN_CHL1_BASE_ADDR_DEF     (IN_CHL0_BASE_ADDR_DEF+IN_CHL0_BUF_SIZE)
+
+#else // define BIG DMA BUFFER
+
+#define IN_CHL0_UNIT_SIZE_DEF    2000
+#define IN_CHL0_UNIT_NUM_DEF     128
+#define IN_CHL0_CFG_DEF          ((0x60000000) | (IN_CHL0_UNIT_NUM_DEF<<8) | (IN_CHL0_UNIT_SIZE_DEF>>3))
+#define IN_CHL0_BASE_ADDR_DEF     XPORT_CHL0_BASE_ADDR_DEF
+
+#define IN_CHL1_UNIT_SIZE_DEF    512
+#define IN_CHL1_UNIT_NUM_DEF     256
+#define IN_CHL1_CFG_DEF          ((IN_CHL1_UNIT_NUM_DEF<<8) | (IN_CHL1_UNIT_SIZE_DEF>>3))
+#define IN_CHL1_BASE_ADDR_DEF    (IN_CHL0_BASE_ADDR_DEF+0x20000)
+
+#endif // #ifndef CONFIG_XPORT_BIG_DMABUFFER
+
+
+#define DMA0_BUF0_BASE_ADDR         (IN_CHL1_BASE_ADDR_DEF + IN_CHL1_BUF_SIZE)  //(XPORT_MEM_BASE+0x40000)
+#define DMA0_BUF0_SIZE              0x10000
+#define DMA0_BUF1_BASE_ADDR         (DMA0_BUF0_BASE_ADDR + DMA0_BUF0_SIZE) //(XPORT_MEM_BASE+0x50000)
+#define DMA0_BUF1_SIZE              0x10000
+#define DMA0_MAX_BLOCK_SIZE         2048    // 2k  bytes
+#define DMA0_MAX_BLOCK_NUM          16
+
+#define DMA_LIST_HEAD_SIZE          0x800
+#define DMA0_LIST0_HEAD_ADDR        (DMA0_BUF1_BASE_ADDR + DMA0_BUF1_SIZE)  //(XPORT_MEM_BASE+0x80000)
+#define DMA0_LIST1_HEAD_ADDR        (DMA0_LIST0_HEAD_ADDR + DMA_LIST_HEAD_SIZE)    //(XPORT_MEM_BASE+0x80800)
+
+#define MIPS_EXTERNAL_BASE_ADDR     (DMA0_LIST1_HEAD_ADDR + DMA_LIST_HEAD_SIZE)    // size = 0xE000
+#define MIPS_EXTERNAL_SIZE          0xE000
+
+/* Filter Buffer define ******/
+#define FLT_BUF_SIZE_1              0x20000
+
+#if (BASE_DDR_ADDR==0x8000000)
+#define FLT_BUF_SIZE_2              0x10000
+#define FLT_PVR_BUF_SIZE            0x190000
+#else
+#define FLT_BUF_SIZE_2              0x20000
+#define FLT_PVR_BUF_SIZE            0x270000
+#endif
+
+#define FLT_BUF_SIZE(x)             ((x)>FLT_BUF_SIZE_SPLIT ? (((x) > 60)? FLT_PVR_BUF_SIZE:FLT_BUF_SIZE_2): FLT_BUF_SIZE_1)
+#define FLT_BUF_SIZE_SPLIT          (36)
+#define FLT_BUF_BASE                (MIPS_EXTERNAL_BASE_ADDR + MIPS_EXTERNAL_SIZE)//(XPORT_MEM_BASE+0x90000)
+
+#define FLT_NORMAL_SIZE_SUM(x)      (((x)>FLT_BUF_SIZE_SPLIT) ? (FLT_BUF_SIZE_1 * FLT_BUF_SIZE_SPLIT + FLT_BUF_SIZE_2 * (x-FLT_BUF_SIZE_SPLIT)) : (FLT_BUF_SIZE_1 * (x)) )
+#define FLT_NORMAL_BASE_ADDR(y)     (FLT_BUF_BASE + FLT_NORMAL_SIZE_SUM(y))
+#define FLT_PVR_BUFF_ADDR(m)        (FLT_NORMAL_BASE_ADDR(61) + (m-61)*FLT_PVR_BUF_SIZE) // m should be 61,62
+#define FLT_BUF_BASE_ADDR(n)        ((n)<61 ?(FLT_NORMAL_BASE_ADDR(n)): (FLT_PVR_BUFF_ADDR(n)))
+
+#define XPORT_MEM_USED_SIZE         (FLT_PVR_BUFF_ADDR(63) - XPORT_MEM_BASE) //(FLT_BUF_BASE - XPORT_MEM_BASE + FLT_BUF_SIZE * 61 + FLT_PVR_BUF_SIZE * 2)
+
+
+/***********Driver Constant Defines*********/
+#define XPORT_MAJOR                 100
+#define XPORT_MINOR                 0
+
+/*VID now support to 8 channels. but  with no limit in theory*/
+#define XPORT_MAX_CHL_NUM           2
+#define XPORT_AV_CHNL_NUM           8
+#define XPORT_MINOR_CHL(n)          (10+n)
+#define XPORT_MINOR_FT_BASE         100
+
+
+#define XPORT_CFG0_TUNER0_SER_MOD       0x00000001
+#define XPORT_CFG0_TUNER1_SER_MOD       0x00000002
+#define XPORT_CFG0_CHL0_DMA_EN          0x00000004
+#define XPORT_CFG0_CHL1_DMA_EN          0x00000010
+#define XPORT_CFG0_CHL0_ATSC_EN         0x00000100
+#define XPORT_CFG0_CHL1_ATSC_EN         0x00000200
+
+#define XPORT_CFG1_OUT_CHL0_LINE_SYNC   0x00000001
+#define XPORT_CFG1_OUT_CHL1_LINE_SYNC   0x00000002
+#define XPORT_CFG1_OUT_CHL2_LINE_SYNC   0x00000004
+#define XPORT_CFG1_OUT_CHL3_LINE_SYNC   0x00000008
+
+#define XPORT_TUNER0_EN                 0x00000001
+#define XPORT_TUNER1_EN                 0x00000002
+
+#define XPORT_IRQ0_ID                   100
+#define XPORT_IRQ1_ID                   101
+
+/************ Driver Macro Defines*********/
+extern void __iomem *xport_regs_base;
+extern void __iomem *xport_mem_base;
+
+#define __IS_HW_ADDR__(x)              (((x)&0xbff00000)==XPORT_REG_ADDR_BASE)
+#define __IS_MIPS_ADDR__(x)            (((x)&0xbff00000)==(XPORT_REG_ADDR_BASE+0x100000))
+#define __WR_FLAGS__(x)                (((x)>>30)&0x1)
+#define __OFFSET_ADDR__(x)             ((x)&0x000fffff)
+
+void xport_writeb(int a,int v);
+void xport_writew(int a,int v);
+void xport_writel(int a,int v);
+unsigned char xport_readb(int a);
+unsigned short xport_readw(int a);
+unsigned int xport_readl(int a);
+
+/******Xport Data Object*********/
+typedef enum
+{
+	XPORT_INPUT_TS_TYPE = 0,
+	XPORT_INPUT_M2TS_TYPE,
+	XPORT_INPUT_TS204_TYPE,
+	XPORT_INPUT_OTHER_TYPE
+} XPORT_STREAM_TYPE;
+
+typedef struct XPORT_DEV_t {
+	unsigned int dev_minor;
+	XPORT_FILTER_TYPE filter_type;
+	XPORT_STREAM_TYPE stream_type;
+	ssize_t packet_size;
+	wait_queue_head_t wait_queue;
+	wait_queue_head_t *irq_wait_queue_ptr;
+	spinlock_t spin_lock;
+	struct semaphore xport_sem;
+
+} XPORT_DEV;
+
+typedef struct DMA_LIST_NODE_t {
+	unsigned int buf_addr;
+	unsigned int data_size;
+	struct DMA_LIST_NODE_t *next_addr;
+	unsigned int next_valid;
+} DMA_LIST_NODE;
+
+typedef struct DMA_LIST_t {
+	DMA_LIST_NODE *head_node;
+	unsigned int max_block_size;
+	unsigned int max_block_num;
+	unsigned int cur_index;
+	unsigned int next_index;
+	unsigned int locked_flag;
+	unsigned int block_size_sum;
+} DMA_LIST;
+
+typedef struct XPORT_DMA_t {
+	DMA_LIST dma_list[2];
+	unsigned long next_jiffies;
+	unsigned int cur_index;
+	struct semaphore dma_sem;
+} XPORT_DMA;
+
+typedef struct XPORT_DIR_T{
+	struct semaphore dir_sem;
+}XPORT_DIR;
+
+
+#define XPORT_FILTER_IOC_PID0           _IOW('k', 1, int)
+#define XPORT_FILTER_IOC_PID1           _IOW('k', 2, int)
+#define XPORT_FILTER_IOC_PID2           _IOW('k', 3, int)
+#define XPORT_FILTER_IOC_PID3           _IOW('k', 4, int)
+#define XPORT_FILTER_IOC_FILTER         _IOW('k', 5, int)
+
+#define XPORT_FILTER_IOC_TYPE           _IOW('k', 6, int)
+#define XPORT_FILTER_IOC_ENABLE         _IOW('k', 8, int)
+
+#define XPORT_FILTER_IOC_QUERY_NUM      _IOR('k', 10, int)
+#define XPORT_FILTER_IOC_QUERY_SIZE     _IOR('k', 11, int)
+
+#define XPORT_FILTER_IOC_CRC_ENABLE     _IOW('k', 12, int)
+
+#define XPORT_PIDFT_IOC_ENABLE          _IOW('k', 13, int)
+#define XPORT_PIDFT_IOC_CHANNEL         _IOW('k', 14, int)
+#define XPORT_PIDFT_IOC_PIDVAL          _IOW('k', 15, int)
+#define XPORT_PIDFT_IOC_DESC_ODDKEY     _IOW('k', 16, int)
+#define XPORT_PIDFT_IOC_DESC_EVENKEY    _IOW('k', 17, int)
+#define XPORT_PIDFT_IOC_DESC_ENABLE     _IOW('k', 18, int)
+
+#define XPORT_CHL_IOC_ENABLE            _IOW('k', 19, int)
+#define XPORT_CHL_IOC_INPUT_MODE        _IOW('k', 20, int)
+#define XPORT_CHL_IOC_RESET             _IOW('k', 21, int)
+#define XPORT_CHL_IOC_DMA_RESET         _IOW('k', 22, int)
+
+#define XPORT_VID_IOC_OUTPUT_MODE       _IOW('k', 23, int)
+#define XPORT_VID_IOC_RESET             _IOW('k', 24, int)
+#define XPORT_VID_IOC_ENABLE            _IOW('k', 25, int)
+#define XPORT_VID_IOC_PIDVAL            _IOW('k', 26, int)
+
+#define XPORT_AUD_IOC_OUTPUT_MODE       _IOW('k', 27, int)
+#define XPORT_AUD_IOC_RESET             _IOW('k', 28, int)
+#define XPORT_AUD_IOC_ENABLE            _IOW('k', 29, int)
+#define XPORT_AUD_IOC_PIDVAL            _IOW('k', 30, int)
+
+#define XPORT_PCR_IOC_ENABLE            _IOW('k', 31, int)
+#define XPORT_PCR_IOC_GETVAL            _IOW('k', 32, int)
+#define XPORT_PCR_IOC_PIDVAL            _IOW('k', 33, int)
+
+#define XPORT_FW_INIT                   _IOW('k', 34, int)
+#define XPORT_FILTER_IOC_CRC_NTF_ENB    _IOW('k', 35, int)
+#define XPORT_FILTER_IOC_SAVE_ENABLE    _IOW('k', 36, int)
+
+#define XPORT_FILTER_IOC_PID4           _IOW('k', 37, int)
+#define XPORT_FILTER_IOC_PID5           _IOW('k', 38, int)
+#define XPORT_FILTER_IOC_PID6           _IOW('k', 39, int)
+#define XPORT_FILTER_IOC_PID7           _IOW('k', 40, int)
+#define XPORT_FILTER_IOC_PID8           _IOW('k', 41, int)
+#define XPORT_FILTER_IOC_PID9           _IOW('k', 42, int)
+#define XPORT_FILTER_IOC_PID10          _IOW('k', 43, int)
+#define XPORT_FILTER_IOC_PID11          _IOW('k', 44, int)
+
+#define XPORT_CHL_IOC_CLEAR             _IOW('k', 45, int)
+#define XPORT_CHL_IOC_TUNER_MODE        _IOW('k', 46, int)
+
+#define XPORT_VID_IOC_SWITCH            _IOW('k', 47, int)
+#define XPORT_AUD_IOC_SWITCH            _IOW('k', 48, int)
+#define XPORT_FILTER_IOC_SWITCH         _IOW('k', 49, int)
+#define XPORT_CHL_IOC_DES_MODE          _IOW('k', 50, int)
+
+#define XPORT_IOC_MEM_BASE_PHYADDR      _IOR('k', 51, int)
+#define XPORT_IOC_MEM_SIZE              _IOR('k', 52, int)
+#define XPORT_FILTER_IOC_BUFFER_UPADDR  _IOR('k', 53, int)
+#define XPORT_FILTER_IOC_BUFFER_LOWADDR _IOR('k', 54, int)
+#define XPORT_FILTER_IOC_BUFFER_RP_ADDR _IOR('k', 55, int)
+#define XPORT_FILTER_IOC_BUFFER_WP_ADDR _IOR('k', 56, int)
+
+#define XPORT_CHL_IOC_UNIT_NUM_DEF      _IOR('k', 57, int)
+#define XPORT_CHL_IOC_UNIT_SIZE_DEF     _IOR('k', 58, int)
+#define XPORT_CHL_IOC_MIN_SPACES        _IOR('k', 59, int)
+#define XPORT_DMA_IOC_ENABLE            _IOR('k', 60, int)
+
+#define XPORT_FLT_IOC_CLEAR             _IOR('k', 61, int)
+#define XPORT_TUN_IOC_ENABLE            _IOR('k', 63, int)
+#define XPORT_TUN_IOC_DISABLE           _IOR('k', 64, int)
+
+#define XPORT_CHL_IOC_INPUT_TYPE        _IOR('k', 65, int)
+#define XPORT_CHL_IOC_SERIAL_MODE       _IOW('k', 66, int)
+
+#define XPORT_IOC_DMA0_LIST0_HEAD_ADDR  _IOR('k', 70, int)
+#define XPORT_IOC_DMA0_BUF0_BASE_ADDR   _IOR('k', 71, int)
+#define XPORT_IOC_DMA0_LIST1_HEAD_ADDR  _IOR('k', 72, int)
+#define XPORT_IOC_DMA0_BUF1_BASE_ADDR   _IOR('k', 73, int)
+#define XPORT_IOC_DMA0_MAX_BLOCK_SIZE   _IOR('k', 74, int)
+#define XPORT_IOC_DMA0_MAX_BLOCK_NUM    _IOR('k', 75, int)
+
+#define XPORT_IOC_ENABLE_TSOUT          _IOR('k', 84, int)
+
+#endif
+
+
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/celestial/xport/xport_filter1900.c linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/xport/xport_filter1900.c
--- linux-linaro-3.4-2012.05-1_original/drivers/celestial/xport/xport_filter1900.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/xport/xport_filter1900.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,629 @@
+/*
+ *  Copyright (C) 2010 Celestial Corporation
+ *  sdk@celestialsemi.cn 
+ */
+
+#include <linux/module.h>
+#include <linux/types.h>
+#include <linux/kernel.h>
+#include <linux/fs.h>
+#include <linux/miscdevice.h>
+#include <linux/init.h>
+#include <linux/ioport.h>
+#include <asm/uaccess.h>
+#include <linux/io.h> 
+#include <linux/semaphore.h>
+
+#include <linux/sched.h>
+#include <linux/poll.h>
+#include <linux/spinlock.h>
+#include <linux/delay.h>
+#include <linux/sched.h>
+#include <linux/interrupt.h>
+
+#include "xport_drv1900.h"
+#include "xport_filter1900.h"
+#include "xport_mips1900.h"
+
+/*mips cmd */
+#define  FLT_CMD_BASE                     (XPORT_AV_CHNL_NUM << 9)
+#define SECTION_BUCKET_SIZE               0x1000
+
+#define  FLT_EN_ADDR(x)                   (FLT_CMD_BASE+(x<<8))  
+#define  FLT_FLT0_ADDR(x)                 (FLT_CMD_BASE+0x1+(x<<8))
+#define  FLT_FLT1_ADDR(x)                 (FLT_CMD_BASE+0x2+(x<<8))
+#define  FLT_FLT2_ADDR(x)                 (FLT_CMD_BASE+0x3+(x<<8))
+#define  FLT_MASK0_ADDR(x)                (FLT_CMD_BASE+0x4+(x<<8))
+#define  FLT_MASK1_ADDR(x)                (FLT_CMD_BASE+0x5+(x<<8))
+#define  FLT_MASK2_ADDR(x)		          (FLT_CMD_BASE+0x6+(x<<8))
+#define  FLT_BUF_LOW_ADDR(x)              (FLT_CMD_BASE+0x07+(x<<8))
+#define  FLT_BUF_UP_ADDR(x)               (FLT_CMD_BASE+0x08+(x<<8))
+
+#define  FLT_TC0_ERR_CNT_ADDR(x)          (FLT_CMD_BASE+0x0a+(x<<8))
+#define  FLT_TC1_ERR_CNT_ADDR(x)          (FLT_CMD_BASE+0x0b+(x<<8))
+#define  FLT_TC2_ERR_CNT_ADDR(x)          (FLT_CMD_BASE+0x0c+(x<<8))
+#define  FLT_TC3_ERR_CNT_ADDR(x)          (FLT_CMD_BASE+0x0d+(x<<8))
+#define  FLT_ERR_PACKET_CNT_ADDR(x)       (FLT_CMD_BASE+0x0e+(x<<8))
+#define  FLT_OUT_PACKET_CNT_ADDR(x)       (FLT_CMD_BASE+0x0f+(x<<8))
+
+#define  FLT_DISABLE_ADDR(x)		  		(FLT_CMD_BASE+0x36+(x<<8))
+#define  PID_CMD_BASE                     (FLT_CMD_BASE+0x16)
+/***********************n~(0,11)   x~(0,62)**********************/
+#define  FLT_PID_ADDR(n,x)                (PID_CMD_BASE+n+(x<<8))
+#define  FLT_BUF_WP_ADDR(x)               (XPORT_REG_ADDR_BASE+0x440+(x<<3))
+#define  FLT_BUF_RP_ADDR(x)               (XPORT_REG_ADDR_BASE+0x444+(x<<3))
+
+
+typedef enum
+{
+	RSV_OUTPUT = 0,
+	TS_OUTPUT = 1,
+	ES_OUTPUT,
+	SEC_OUTPUT,
+	PES_OUTPUT
+}CHL_OUTPUT_TYPE;
+
+
+inline unsigned int get_filter_buf_base_addr(unsigned int filter_index)
+{
+	unsigned int idx = filter_index;
+
+	return (idx>= 0&&idx<MAX_FILTER_NUM ? FLT_BUF_BASE_ADDR(idx):-1);
+}
+
+inline unsigned int get_filter_buf_top_addr(unsigned int filter_index)
+{
+	unsigned int idx = filter_index;
+	return (idx>= 0&&idx<MAX_FILTER_NUM ?(FLT_BUF_BASE_ADDR(idx + 1)):-1);
+}
+
+inline unsigned int get_filter_buf_size(unsigned int filter_index) 
+{
+	unsigned int idx = filter_index;
+	return ((idx>= 0&&idx<MAX_FILTER_NUM) ? (FLT_BUF_SIZE(idx)): -1);
+}
+
+
+inline unsigned int get_xport_filter_wp(unsigned int filter_index)
+{
+	return xport_readl(FLT_BUF_WP_ADDR(filter_index));
+}
+
+inline unsigned int get_xport_filter_rp(unsigned int filter_index)
+{
+	return xport_readl(FLT_BUF_RP_ADDR(filter_index));
+}
+
+
+int xport_filter_reset(unsigned int filter_index)
+{
+	unsigned int idx = filter_index;
+	xport_mips_write(FLT_DISABLE_ADDR(idx),0);
+	xport_mips_write(FLT_BUF_LOW_ADDR(idx),get_filter_buf_base_addr(idx));
+	xport_mips_write(FLT_BUF_UP_ADDR(idx),get_filter_buf_top_addr(idx));
+	xport_writel(FLT_BUF_WP_ADDR(idx),get_filter_buf_base_addr(idx));
+	xport_writel(FLT_BUF_RP_ADDR(idx),get_filter_buf_base_addr(idx));
+
+	return 0;
+}
+
+
+/**set filter type cmd to I/D ram of MIPs**/
+int xport_filter_set_type(unsigned int filter_index, XPORT_FILTER_TYPE filter_type)
+{
+	unsigned int en;
+	int rt;
+	unsigned int idx = filter_index;
+	XPORT_FILTER_TYPE ft = filter_type;
+
+
+	rt = xport_mips_read(FLT_EN_ADDR(idx), &en);
+
+	/* bit31: enable flag: 1 - output channel enabled */
+	en = xport_get_bit(en,31); 
+
+	if (rt == 0  &&  en == 0) 
+	{
+		en = (ft==FILTER_TYPE_SECTION ? SEC_OUTPUT:
+				(ft==FILTER_TYPE_TS ? TS_OUTPUT:
+				 (ft==FILTER_TYPE_PES? PES_OUTPUT:
+				  (ft==FILTER_TYPE_ES ? ES_OUTPUT : RSV_OUTPUT))));
+
+		xport_mips_write(FLT_EN_ADDR(idx), en);
+
+		return 0;
+	}
+
+	return -1;
+}
+
+int xport_filter_set_input(unsigned int filter_index, XPORT_INPUT_CHANNEL input_channel)
+{
+	return -1;
+}
+
+int xport_filter_set_crc(unsigned int filter_index, unsigned int crc_index)
+{
+	return -1;
+}
+
+int xport_filter_set_pidx(unsigned int filter_index, unsigned int pid, unsigned int slot)
+{
+	if(filter_index >=0 && filter_index <= 60 && slot>0)
+	{
+		printk("wrong operation.filter idx 0-61 shoule with only slot 0 work! \n");
+		return -1;
+	}
+
+	return slot>=0&&slot<=11 ? xport_mips_write(FLT_PID_ADDR(slot,filter_index),pid):-1;
+}
+
+int xport_filter_set_filter(unsigned int filter_index, unsigned char *filter, unsigned char *mask)
+{
+	xport_mips_write(FLT_FLT0_ADDR(filter_index), *(unsigned int *) filter);
+	xport_mips_write(FLT_FLT1_ADDR(filter_index), *(unsigned int *) (filter + 4));
+	xport_mips_write(FLT_FLT2_ADDR(filter_index), *(unsigned int *) (filter + 8));
+	xport_mips_write(FLT_MASK0_ADDR(filter_index), *(unsigned int *) mask);
+	xport_mips_write(FLT_MASK1_ADDR(filter_index), *(unsigned int *) (mask + 4));
+	xport_mips_write(FLT_MASK2_ADDR(filter_index), *(unsigned int *) (mask + 8));
+
+	return 0;
+}
+
+int xport_filter_crc_enable(unsigned int filter_index)
+{
+	return -1;
+}
+
+int xport_filter_crc_disable(unsigned int filter_index)
+{
+	return -1;
+}
+
+int xport_filter_crc_is_enable(unsigned int filter_index)
+{
+	return -1;
+}
+
+int xport_filter_enable(unsigned int filter_index, spinlock_t * spin_lock_ptr)
+{
+	int rt;
+	unsigned int en;
+	unsigned long irq1_en;
+	unsigned long spin_flags;
+
+	rt = xport_mips_read(FLT_EN_ADDR(filter_index), &en);
+
+	if(rt != 0)
+	{
+		return -1;
+	}
+
+	/**asign iomem addr into filter's register**/
+
+	xport_writel(FLT_BUF_RP_ADDR(filter_index), get_filter_buf_base_addr(filter_index));
+	spin_lock_irqsave(spin_lock_ptr, spin_flags);
+	irq1_en = (filter_index <32 ? xport_readl(XPORT_INT_ENB_ADDR1): xport_readl(XPORT_INT_ENB_ADDR0));	 	
+	irq1_en |=(filter_index<32 ? 1<<filter_index : XPORT_IRQ0_FILTER_NOTIFY);
+
+
+	if(filter_index <32)
+	{
+		xport_writel(XPORT_INT_CLS_ADDR1, (1 << filter_index));
+	}
+
+	xport_writel((filter_index<32? XPORT_INT_ENB_ADDR1: XPORT_INT_ENB_ADDR0),irq1_en);
+	spin_unlock_irqrestore(spin_lock_ptr, spin_flags);
+
+	return xport_mips_write(FLT_EN_ADDR(filter_index), 0x80000000 | en);
+}
+
+
+int xport_filter_disable(unsigned int filter_index, spinlock_t * spin_lock_ptr)
+{
+	int rt;
+	unsigned int en;
+	unsigned long irq1_en;
+	unsigned long spin_flags;
+
+
+	rt = xport_mips_read(FLT_EN_ADDR(filter_index), &en);
+
+	if (rt != 0)
+		return -1;
+
+
+	spin_lock_irqsave(spin_lock_ptr, spin_flags);
+
+	irq1_en = (filter_index <32 ? xport_readl(XPORT_INT_ENB_ADDR1) : xport_readl(XPORT_INT_ENB_ADDR0));
+	irq1_en&=(~(filter_index<32?1<<filter_index: XPORT_IRQ0_FILTER_NOTIFY));
+	xport_writel((filter_index<32?XPORT_INT_ENB_ADDR1: XPORT_INT_ENB_ADDR0),irq1_en);
+	spin_unlock_irqrestore(spin_lock_ptr, spin_flags);
+
+#if 1
+	return xport_mips_write(FLT_EN_ADDR(filter_index), 0x7fffffff & en);
+#else
+	return xport_mips_write(FILTER_DISABLE_ADDR(filter_index), 0);
+#endif
+
+
+}
+
+int xport_filter_is_enable(unsigned int filter_index)
+{
+	int rt;
+	unsigned int en;
+
+	rt = xport_mips_read(FLT_EN_ADDR(filter_index), &en);
+	en >>= 31;
+
+	if (rt == 0)
+		return en;
+
+	return -1;
+}
+/* seciton filter */
+int xport_filter_check_section_number(unsigned int filter_index)
+{
+	unsigned int len;
+	unsigned int wp, wp_tog;
+	unsigned int rp, rp_tog;
+	unsigned int up_addr, low_addr;
+
+
+	up_addr = get_filter_buf_top_addr(filter_index);
+	low_addr = get_filter_buf_base_addr(filter_index);
+	wp = xport_readl(FLT_BUF_WP_ADDR(filter_index));
+	rp = xport_readl(FLT_BUF_RP_ADDR(filter_index));
+
+
+	wp_tog = wp & 0x80000000;
+	rp_tog = rp & 0x80000000;
+
+	wp = wp & 0x7fffffff;
+	rp = rp & 0x7fffffff;
+
+	if (wp_tog == rp_tog) {
+		len = wp - rp;
+	}
+	else {
+		len = (up_addr - low_addr) + wp - rp;
+	}
+
+	len = len & 0xfffff000;
+
+	return len;
+}
+
+int xport_filter_check_section_size(unsigned int filter_index)
+{
+	return 0;
+}
+
+int xport_filter_clear_buffer(unsigned int filter_index)
+{
+	xport_writel(FLT_BUF_RP_ADDR(filter_index), get_filter_buf_base_addr(filter_index));
+	xport_writel(FLT_BUF_WP_ADDR(filter_index), get_filter_buf_base_addr(filter_index));
+
+	return 0;
+}
+
+int xport_filter_read_section_data(unsigned int filter_index, char __user * buffer, size_t len)
+{
+	void __iomem *read_addr;	
+	unsigned int rp, rp_tog;
+	unsigned int section_len;
+
+	if (xport_filter_check_section_number(filter_index) <= 0) {
+		return -1;
+	}
+
+	rp = xport_readl(FLT_BUF_RP_ADDR(filter_index));
+
+	rp_tog = rp & 0x80000000;
+	rp = rp & 0x7fffffff;
+
+	read_addr = xport_mem_base + (rp - XPORT_MEM_BASE);
+
+	section_len = ((unsigned char *) read_addr)[1];
+	section_len <<= 8;
+	section_len += ((unsigned char *) read_addr)[2];
+	section_len &= 0xfff;
+	section_len += 3;
+
+
+
+	if(section_len > 4096 || section_len > len) {
+		return -EFAULT;
+	}
+
+	if(copy_to_user(buffer, read_addr, section_len)) {
+		return -EFAULT;
+	}
+
+	rp += 0x1000;
+
+	if(rp >= get_filter_buf_top_addr(filter_index)) 
+	{
+		rp = get_filter_buf_base_addr(filter_index);
+		rp_tog = rp_tog ^ 0x80000000;
+	}	
+	xport_writel(FLT_BUF_RP_ADDR(filter_index), rp_tog | rp);
+
+
+
+	return section_len;
+}
+/* ts filter */
+int xport_filter_check_data_size(unsigned int filter_index)
+{
+	unsigned int len = 0;
+	unsigned int wp, wp_tog;
+	unsigned int rp, rp_tog;
+	unsigned int up_addr, low_addr;
+
+	up_addr = get_filter_buf_top_addr(filter_index);
+	low_addr = get_filter_buf_base_addr(filter_index);
+
+	wp = xport_readl(FLT_BUF_WP_ADDR(filter_index));
+	rp = xport_readl(FLT_BUF_RP_ADDR(filter_index));
+
+	wp_tog = wp & 0x80000000;
+	rp_tog = rp & 0x80000000;
+	wp = wp & 0x7fffffff;
+	rp = rp & 0x7fffffff;
+
+	if (wp_tog == rp_tog) {
+		len = wp - rp;
+	}
+	else {
+		len = (up_addr - low_addr) + wp - rp;
+	}
+
+	len = (len / 188) * 188;  
+
+	return len;
+}
+
+
+int xport_filter_read_data(unsigned int filter_index, char __user * buffer, size_t len)
+{
+	void __iomem *read_addr;
+
+	unsigned int rp, rp_tog;
+	unsigned int size_tmp;
+
+	/*check available data in buffer for reading*/
+	if (xport_filter_check_data_size(filter_index) < len)
+		return -1;
+
+	rp = xport_readl(FLT_BUF_RP_ADDR(filter_index));
+	rp_tog = rp & 0x80000000;
+	rp = rp & 0x7fffffff;
+
+	size_tmp = get_filter_buf_top_addr(filter_index) - rp;
+
+	if(size_tmp <= len) 
+	{
+		read_addr = xport_mem_base + (rp - XPORT_MEM_BASE);
+		if (copy_to_user(buffer, read_addr, size_tmp))
+			return -EFAULT;
+
+		len -= size_tmp;
+		buffer += size_tmp;
+		size_tmp += len;
+
+		rp = get_filter_buf_base_addr(filter_index);
+		rp_tog = rp_tog ^ 0x80000000;
+	}
+	else
+		size_tmp = len;
+
+	if (len > 0) {
+		read_addr = xport_mem_base + (rp - XPORT_MEM_BASE);
+		if (copy_to_user(buffer, read_addr, len))
+			return -EFAULT;
+
+		rp += len;
+	}
+
+	xport_writel(FLT_BUF_RP_ADDR(filter_index), rp_tog | rp);
+
+
+	return size_tmp;
+}
+
+
+
+/* pes filter */
+int xport_filter_check_pes_size(unsigned int filter_index)
+{
+	int len;
+	unsigned int pes_len = 0;
+
+	unsigned int wp, wp_tog;
+	unsigned int rp, rp_tog;
+	unsigned int up_addr, low_addr;
+
+	unsigned int section_size, data[3];
+	unsigned int mask = SECTION_BUCKET_SIZE - 1;
+	void __iomem *read_addr;
+
+	up_addr = get_filter_buf_top_addr(filter_index);
+	low_addr = get_filter_buf_base_addr(filter_index);
+
+	wp = xport_readl(FLT_BUF_WP_ADDR(filter_index));
+	rp = xport_readl(FLT_BUF_RP_ADDR(filter_index));
+
+	wp_tog = wp & 0x80000000;
+	rp_tog = rp & 0x80000000;
+	wp = wp & (0x7fffffff & ~mask);
+	rp = rp & (0x7fffffff & ~mask);
+
+	if (wp_tog == rp_tog) {
+		len = wp - rp;
+	}
+	else {//?
+		len = (up_addr - low_addr) + wp - rp;
+	}
+
+	if (len < SECTION_BUCKET_SIZE)
+		return 0;
+
+	if (rp & mask) 	 /* rp is not aligned with 0x1000 size */
+		return -EFAULT;
+
+	section_size = 0;
+
+	/* find the position that new pes packet starts */
+	while ((len & ~mask) > 0) {
+		read_addr = xport_mem_base + (rp - XPORT_MEM_BASE);
+
+		data[0] = *(unsigned int *) (read_addr);	 /* first 4 byte of bucket header */
+		data[1] = *(unsigned int *) (read_addr + 4);
+		data[2] = *(unsigned int *) (read_addr + 8);
+
+		if ((data[0] & 0x010000) && ((data[1] & 0xffffff) == 0x010000)) {	 /* new pes packet */
+			section_size += data[0] & 0xffff;
+			section_size -= 4;
+			pes_len = (data[2] & 0xff) << 8;
+			pes_len |= (data[2] & 0xff00) >> 8;
+
+			xport_writel(FLT_BUF_RP_ADDR(filter_index), rp | rp_tog);
+
+			rp += SECTION_BUCKET_SIZE;
+			len -= SECTION_BUCKET_SIZE;
+
+			if (rp >= up_addr) {
+				rp = low_addr;
+				rp_tog ^= 0x80000000;
+			}
+
+			break;
+		}
+
+		rp += SECTION_BUCKET_SIZE;
+		len -= SECTION_BUCKET_SIZE;
+
+		if (rp >= up_addr) {
+			rp = low_addr;
+			rp_tog ^= 0x80000000;
+		}
+	}
+
+	if (section_size == 0) {	 /* new pes packet is not found */
+		xport_writel(FLT_BUF_RP_ADDR(filter_index), (wp & 0xfffff000) | wp_tog);
+		return 0;
+	}
+
+	/* 
+	 * find the the position of next new pes packet, to get the 
+	 * size of current pes packet
+	 */
+	while (len > 0) {
+		read_addr = xport_mem_base + (rp - XPORT_MEM_BASE);
+		data[0] = *(unsigned int *) (read_addr);	 /* first 4 byte of bucket header */
+		data[1] = *(unsigned int *) (read_addr + 4);
+		data[2] = *(unsigned int *) (read_addr + 8);
+
+		if ((data[0] & 0x010000) && ((data[1] & 0xffffff) == 0x010000))
+			break;
+		else {
+			section_size += (data[0] & 0xffff);
+			section_size -= 4;
+		}
+
+		if (section_size > pes_len + 6)
+			section_size = pes_len + 6;
+
+		if ((section_size == pes_len + 6) && (pes_len != 0))
+			break;  /* video pes is exception */
+
+		rp += SECTION_BUCKET_SIZE;
+		len -= SECTION_BUCKET_SIZE;
+
+		if (rp >= up_addr) {
+			rp = low_addr;
+			rp_tog ^= 0x80000000;
+		}
+	}
+
+	if (len <= 0) {
+		unsigned int buffer_size = up_addr - low_addr;
+		if (section_size >= (buffer_size - (buffer_size >> 10))) {
+			printk(KERN_INFO
+					"PES packet size exceed the size of filter buffer: filter id = %d, buffer size = %d section size = %d\n",
+					filter_index, up_addr - low_addr, section_size);
+			return -EFAULT;
+		}
+		else if ((section_size == pes_len + 6) && (pes_len != 0))
+			return section_size;
+		else
+			/* not find the next pes packet, that means current packet is not ready */
+			return 0;
+	}
+
+	return section_size;
+}
+
+int xport_filter_read_pes_data(unsigned int filter_index, char __user * buffer, size_t len)
+{
+	unsigned int rp, rp_tog;
+	unsigned int up_addr, low_addr;
+	unsigned int data, bucket_size;
+	int pes_size, byte_written;
+	unsigned int mask = SECTION_BUCKET_SIZE - 1;
+
+	void __iomem *read_addr;
+
+	pes_size = xport_filter_check_pes_size(filter_index);
+	if (pes_size <= 0) {
+		printk(KERN_INFO "pes size = %d, empty now \n", pes_size);
+		return -EFAULT;
+	}
+	if (pes_size > len)
+		pes_size = len;
+
+	byte_written = pes_size;
+
+	up_addr = get_filter_buf_top_addr(filter_index);
+	low_addr = get_filter_buf_base_addr(filter_index);
+
+	rp = xport_readl(FLT_BUF_RP_ADDR(filter_index));
+
+	rp_tog = rp & 0x80000000;
+	rp = rp & 0x7fffffff;
+	if (rp & mask) {	 /* rp is not aligned with 0x1000 */
+		printk(KERN_INFO "rp 0x%08x is not aligned with 0x1000\n", rp);
+		return -EFAULT;
+	}
+
+	while (pes_size > 0) {
+		read_addr = xport_mem_base + (rp - XPORT_MEM_BASE);
+		data = *(unsigned int *) read_addr; /* first 4 byte of bucket header */
+		read_addr += 4;
+		bucket_size = (data & 0xffff);
+		bucket_size -= 4;
+
+		if (bucket_size > pes_size)
+			bucket_size = pes_size;
+
+		if (copy_to_user(buffer, read_addr, bucket_size) > 0) {
+			printk(KERN_INFO " user buffer is not enough \n");
+			return -EFAULT;
+		}
+
+		pes_size -= bucket_size;
+		buffer += bucket_size;
+		rp += SECTION_BUCKET_SIZE;
+
+		if (rp >= up_addr) {
+			rp = low_addr;
+			rp_tog ^= 0x80000000;
+		}
+	}
+
+	xport_writel(FLT_BUF_RP_ADDR(filter_index), rp_tog | rp);
+
+	return byte_written;
+}
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/celestial/xport/xport_filter1900.h linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/xport/xport_filter1900.h
--- linux-linaro-3.4-2012.05-1_original/drivers/celestial/xport/xport_filter1900.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/xport/xport_filter1900.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,70 @@
+#ifndef __XPORT_FILTER_H__
+#define __XPORT_FILTER_H__
+
+typedef enum {
+	FILTER_TYPE_NUKOWN = -1,
+	FILTER_TYPE_SECTION = 0,
+	FILTER_TYPE_TS,
+	FILTER_TYPE_PES,
+	FILTER_TYPE_ES
+} XPORT_FILTER_TYPE;
+
+typedef enum {
+	INPUT_CHANNEL_0 = 0,
+	INPUT_CHANNEL_1,
+	INPUT_CHANNEL_2,
+	INPUT_CHANNEL_3	
+} XPORT_INPUT_CHANNEL;
+
+typedef enum {
+    INPUT_DMA0 = 0,
+	INPUT_DMA1
+}XPORT_DMA_INPUT_TYPE ;
+
+
+#define XPORT_IRQ0_CRC_NOTIFY		0x00000100
+#define XPORT_IRQ0_CRC_INDEX		0x00007e00
+#define XPORT_IRQ0_CRC_IDX_SHIFT	0x9
+#define XPORT_IRQ0_FILTER_NOTIFY	0x00008000	/* filter index > 31 */
+#define XPORT_IRQ0_FILTER_INDEX		0x003f0000
+#define XPORT_IRQ0_FILTER_IDX_SHIFT	0x10
+
+
+int xport_filter_reset(unsigned int filter_index);
+
+int xport_filter_set_type(unsigned int filter_index, XPORT_FILTER_TYPE filter_type);
+int xport_filter_set_input(unsigned int filter_index, XPORT_INPUT_CHANNEL input_channel);
+int xport_filter_set_crc(unsigned int filter_index, unsigned int crc_index);
+
+int xport_filter_set_pidx(unsigned int filter_index, unsigned int pid, unsigned int slot);
+
+int xport_filter_set_filter(unsigned int filter_index, unsigned char *filter, unsigned char *mask);
+
+int xport_filter_crc_enable(unsigned int filter_index);
+int xport_filter_crc_disable(unsigned int filter_index);
+int xport_filter_crc_is_enable(unsigned int filter_index);
+
+int xport_filter_enable(unsigned int filter_index, spinlock_t * spin_lock_ptr);
+int xport_filter_disable(unsigned int filter_index, spinlock_t * spin_lock_ptr);
+int xport_filter_is_enable(unsigned int filter_index);
+
+int xport_filter_check_section_number(unsigned int filter_index);
+int xport_filter_check_section_size(unsigned int filter_index);
+int xport_filter_read_section_data(unsigned int filter_index, char __user * buffer, size_t len);
+
+int xport_filter_check_data_size(unsigned int section_filter_id);
+int xport_filter_read_data(unsigned int section_filter_id, char __user * buffer, size_t len);
+
+int xport_filter_check_pes_size(unsigned int filter_index);
+int xport_filter_read_pes_data(unsigned int filter_index, char __user * buffer, size_t len);
+
+int xport_filter_clear_buffer(unsigned int filter_index);
+
+unsigned int get_filter_buf_base_addr(unsigned int filter_index);
+unsigned int get_filter_buf_top_addr(unsigned int filter_index);
+unsigned int get_filter_buf_size(unsigned int filter_index);
+unsigned int get_xport_filter_rp(unsigned int filter_index);
+unsigned int get_xport_filter_wp(unsigned int filter_index);
+
+#endif
+
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/celestial/xport/xport_mips1900.c linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/xport/xport_mips1900.c
